#+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
# Simple thread plugin package for the SmartGDB GUI
# Author: Charles Dymond <cdy@ittc.ukans.edu>
#+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
cd /net/hegel/d2/rprojects/nachos/nachos-3.4/code/test
thread-debug nachos

global location

global lastSelection
set lastSelection 0

set location .smartgdb.w_frame.newframe

    global location
    frame $location
    
    grid columnconfigure $location 0 -weight 1
    grid columnconfigure $location 1 -weight 0
    grid rowconfigure $location 0 -weight 1
    grid rowconfigure $location 1 -weight 0
    
    text $location.txt \
    -fg blue -bg white -wrap none \
	-xscrollcommand "$location.yscroll set" \
	-yscrollcommand "$location.xscroll set" \
	-width 25 \
	
    scrollbar $location.xscroll \
	-orient horizontal \
    -command "$location.txt xview"
    
    scrollbar $location.yscroll \
	-orient vertical \
    -command "$location.txt yview"


proc new_win { } {

    global location
    global lastSelection
    global highlightFG
    global highlightBG

    pack forget .smartgdb.w_frame
    grid $location $location.txt -column 0 -row 0 -sticky ns
    grid $location $location.xscroll -column 0 -row 1 -sticky ew
    grid $location $location.yscroll -column 1 -row 0 -sticky ns

    pack .smartgdb.w_frame $location

    bind $location.txt <Button-1> {
	global lastSelection
	global highlightFG
	global highlightBG
	
	set name $location.txt
	set line [get_pos $name]
	
	if { $lastSelection != 0 } {
	    $location.txt mark set lfirst $lastSelection.0
	    $location.txt mark set llast $lastSelection.end
	    $location.txt tag remove highlight lfirst llast
	}
	
	$location.txt mark set lfirst $line.0
	$location.txt mark set llast $line.end
	$location.txt tag add highlight lfirst llast
	$location.txt tag configure highlight \
	    -background $highlightBG \
	    -foreground $highlightFG \
	    -relief raised \
	    -borderwidth 1
	
	set lastSelection $line
	
    }
    
    bind $location.txt <Double-Button-1> {
	show_trace
	break
    }

    bind $location.txt <B1-Motion> {
	break
    }

}


new_win

global WPackage
set WPackage new_win

global contlist
append contlist get_threads

menu .pop 
.pop add command -label "stack trace" -command { show_trace }
#.pop add command -label "set-context" -command { }
.pop add command -label "show-context" -command { show_context }

proc get_threads { } {
    global location
    global lastSelected
    global numrunning

    set blurb "[ ls-threads ]"
    set blurb [ split $blurb \n ]

    set test "Program does not have any threads"

    if { ( [string match $test [lindex $blurb 0]] !=1 )&&( [string match $test [lindex $blurb 1]] != 1) } {
	  set blurb [lreplace $blurb 0 0]
	  set blurb [lreplace $blurb end end]
	  set threadlist ""
	  set count 1
	  
	  #+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
	  # extract the pointer ID and its address
	  #+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
	  foreach i $blurb {
	      set i [ split $i " " ]
	      append threadlist [lindex $i 6]
	      append threadlist ":  "
	      append threadlist [lindex $i 2]
	      
	      #+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
	      # the running thread will have an additional
	      # field "*****" 
	      #+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
	      if { [lindex $i 7] != "" } {
		  append threadlist " (Running)"
		  set running $count
	      }
	      append threadlist \n
	      incr count
	  }

	  insert_text $location.txt $threadlist
	  set lastSelected 0
	  colour_text $location.txt $running "red"
	  set runningThread [run_thread]
	  set numRunning [expr $count-1]
	  set msg "Number of threads: $numRunning"
	  append msg ", Active thread ID: $runningThread"
    } else {
	set msg $test
    }

    insert_text .smartgdb.status $msg
}


proc run_thread { } {
    set blurb "[ run-thread]"
    set running [lindex $blurb 6]   
    return $running
}

proc show_context { } {

    global lastSelection

    set blurb "[ show-context $lastSelection ]"
    insert_text .smartgdb.text_frame.text $blurb   

}


#+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
# displays stack trace for selected thread
#+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
proc show_trace { } {

    new_bindings

    global lastSelection

    set name .smartgdb.text_frame.text

    set blurb "[ bt-threads $lastSelection ]"
    insert_text $name $blurb
    colour_text $name 1 "red"

    set line 2
    $name mark set lfirst $line.0
    $name mark set llast $line.1
    set char [$name get lfirst llast]

    if { $char=="" } {
	incr line
	set char "#"
    }

    #+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
    # make the first 3 characters (the line 
    # number) of each line of the stack 
    # trace output red
    #+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-	
    while { $char != "" } {
	$name mark set lfirst $line.0
	$name mark set llast $line.3
	$name tag add rt lfirst llast
	$name tag configure rt -foreground red

	incr line
	$name mark set lfirst $line.0
	$name mark set llast $line.1
	set char [$name get lfirst llast]	
    }
}



bind $location.txt <Button-3> {
    set xord [winfo pointerx $location.txt]
    set yord [winfo pointery $location.txt]
    tk_popup .pop $xord $yord 
}


proc new_bindings { } {

    global lastMline

    set name .smartgdb.text_frame.text
    
    bind $name <Double-Button-1> {
	set name .smartgdb.text_frame.text	
	set line [get_selected_line $name  [get_pos $name] ]
	set info ""
	set info [get_source $line]
	set name .smartgdb.text_frame.text

	#+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
	# check that get_source returned
	# something 
	#+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
	if { $info != "" } {
	    
	    #+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
	    # info should be a list of the
	    # source file name and the line 
	    # number separated by a space
	    #+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
	    set info [split $info " "]
	    set source [lindex $info 0]
	    set line_num [lindex $info 1]

	    #+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
	    # display the source file in the 
	    # main window and position the
	    # screen to the line number
	    #+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
	    display_file $source
	    $name see $line_num.0
	    highlight_line $name $line_num
	}
	break
    }

    bind $name <B1-Motion> {
	break
    }
}


#+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
# gets source file and line number from selected line in
# a stack trace for a particular thread
#+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
proc get_source { output } {

    set name .smartgdb.text_frame.text
    set info ""

    #+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
    # first check that the line has source and a line number
    #+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
    if { [regexp {at(.*):([1-9]+[0-9]*)} $output]} {
	set line_num ""
	set source ""

	set pos [string length $output]
	set pos [expr $pos-1]
	set char [string index $output $pos]

	#+-+-+-+-+-+-+-+-+-+-+-+-+-+-
	# extract the line number
	#+-+-+-+-+-+-+-+-+-+-+-+-+-+-
	if { ($char >= "0" )&&( $char <= "9") } {
	    while { $char != ":" } {
		set line_num "$char$line_num"
		set pos [expr $pos-1]
		set char [string index $output $pos]	    
	    }
	    set pos [expr $pos-1]
	    set char [string index $output $pos]

	    #+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
	    # extract the source file name
	    #+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
	    while { $char != " " } {
		set source "$char$source"
		set pos [expr $pos-1]
		set char [string index $output $pos]
	    }	
	    set info [list $source $line_num]
	}
    } else {
	#+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
	# otherwise try the next line 
	#+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
	set output [get_next_line $name [get_pos $name]]
	set first_char [string index $output 0]

	#+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
	# check that the line is not the start of a new
	# entry and that it contains the information wnated
	#+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
	if { ( $first_char != "#" )&&( [regexp {at(.*):([1-9]+[0-9]*)} $output] )} {
	    set info [ get_source $output]
	    return $info
	}
    }
	return $info
}
