

#
# This function takes the output from [i sources] and 
# parses it into individual filenames
#
proc get_source_names {} {
    regsub -all "Source(.*)in:"  [i sources] "," stuff
    regsub -all "Source(.*)demand:"  $stuff "," stuff

    set stuff [split $stuff ,]
    set results ""
    foreach i $stuff {
	set i [string trim $i]
	if { $i != "" } {
	    lappend results $i 
	}
    }
    return $results
}

proc goto_source {} {

    global sourceWindow
    set sourceWindow 1

    toplevel .sources   
    wm geometry .sources 300x400
#    grab .sources
    listbox .sources.list -xscrollcommand { .sources.xscroll set} \
	-yscrollcommand { .sources.yscroll set} \
	-fg blue -bg white 
    .sources.list configure -selectbackground yellow -selectforeground black
    scrollbar .sources.xscroll -orient horizontal -command { .sources.list xview }
    scrollbar .sources.yscroll -orient vertical -command { .sources.list yview }
    frame .sources.buttons
    button .sources.buttons.goto -text "Goto" -command {display_file [selection get]}
    button .sources.buttons.cancel -text "Dismiss" -command {set sourceWindow 0; destroy .sources}
    set sourceNames [get_source_names]
    set sourceNames [lsort -decreasing $sourceNames]

    foreach i $sourceNames {
	.sources.list insert 0 $i 
    }

    .sources.list selection set 0
    pack .sources.buttons.goto .sources.buttons.cancel -side left
    grid columnconfigure .sources 0 -weight 1
    grid columnconfigure .sources 1 -weight 0
    grid rowconfigure .sources 0 -weight 1
    grid rowconfigure .sources 1 -weight 0
    grid rowconfigure .sources 2 -weight 0
    grid .sources.list -column 0 -row 0 -sticky nsew
    grid .sources.yscroll -column 1 -row 0 -sticky nsew
    grid .sources.xscroll -column 0 -row 1 -sticky nsew
    grid .sources.buttons -column 0 -row 2 -sticky nsew -columnspan 2

    bind .sources <Double-Button-1> {display_file [selection get]}
    bind .sources <Return> {display_file [selection get]}
}

